Galaxy = class("Galaxy")
local fail = false

function Galaxy:init(data)
	-- Make a table to hold our stars
	self.stars = {}
	self.civilizations = {}

	-- We're expecting data from the instantiation
	-- of the Galaxy object, below is what we're
	-- expecting. 
	local width = data.width or 1000
	local height = data.height or 1000

	-- Path for the file to read
	-- local path = system.pathForFile( "/classes/star_names.txt", system.ResourceDirectory )
	-- http://lua-users.org/wiki/FileInputOutput

	-- see if the file exists
	function file_exists(file)
	  local f = io.open(file, "rb")
	  if f then f:close() end
	  return f ~= nil
	end

	-- get all lines from a file, returns an empty 
	-- list/table if the file does not exist
	function lines_from(file)
	  if not file_exists(file) then return {} end
	  lines = {}
	  for line in io.lines(file) do 
	    lines[#lines + 1] = line
	  end
	  return lines
	end

	-- tests the functions above
	local file = 'star_names.txt'
	local star_names = lines_from(file)


	local mapSizeX = data.width
	local mapSizeY = data.height

	local totalStars = 100
	-- Make a table to hold civilizations
	local numberOfCivilizations = data.civilizations
	for i=1,numberOfCivilizations do
	-- First determine if the max distance or min distance
	-- is doable. 
		-- We built in functionality to pass a name
		-- of a civilization when creating it, so let's
		-- do that now.
		local myCivilization = Civilization:new("Civilization "..i)
		print("Civilization name: "..myCivilization.name)
		print("Civilization government: "..myCivilization.government.type..": "..myCivilization.government.description)
		print("Civilization species name: "..myCivilization.species.name)
		table.insert(self.civilizations,myCivilization)

		local diameter = screenW*0.15
		local minimumDistance=100
		-- Let's pick a 
		-- random spot on the map and create stars
		-- within a specific distance of that location
		local tempX = RAND(0,mapSizeX)
		local tempY = RAND(0,mapSizeY)
		local numberOfStars = RAND(5,15)
		for j=1,numberOfStars do
			local star_data = {
				name = star_names[#self.stars],
				civilization = myCivilization,
				x = RAND(-diameter,diameter)+tempX,
				y = RAND(-diameter,diameter)+tempY,
			}
			-- print( star_names[#self.stars])
			local myStar = Star:new(star_data)

			table.insert(self.stars,myStar)
		end
	end

	if(fail)then
		print("Fail "..tostring(fail))
	end

end

function Galaxy:GetAllStarsBelongingToACvilization(passedCivilization)
	local result = {}
	for k,v in pairs(self.stars) do
		if(v.civilization==passedCivilization)then
			table.insert(result,v)
		end
	end
	return result
end


--= Return Factory
return Galaxy